import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import java.util.ArrayList;

public class MessreiheAlleWerteGleichOftTest {

  private Messreihe m33244;
  private Messreihe m43243;
  private Messreihe m2344;
  private Messreihe m432432;
  private Messreihe m332445;
  private Messreihe leer;
  private Messreihe mitNullListe;
  private ArrayList<Integer> genutzt;

  private void merkeGenutzteWerte(Messreihe m){
    if (m.getMesswerte() == null){
      return;
    }
    for (int w: m.getMesswerte()) { // in Messreihe keine null-Werte
      this.genutzt.add(w);
    }
  }
  
  private boolean messwerteUnveraendert(Messreihe m){
    if (m.getMesswerte() == null){
      return this.genutzt.size() == 0;
    }
    for(int i = 0; i < this.genutzt.size(); i++) {
      if (this.genutzt.get(i) != m.getMesswerte().get(i)){
        return false;
      }
    }
    return m.getMesswerte().size() == this.genutzt.size();
  }
  
  @BeforeEach
  public void setUp() {
    this.genutzt = new ArrayList<Integer>();
    this.m33244 = new Messreihe("Ort1");
    this.m33244.hinzufuegen(3);
    this.m33244.hinzufuegen(3);
    this.m33244.hinzufuegen(2);
    this.m33244.hinzufuegen(4);
    this.m33244.hinzufuegen(4);
    this.m43243 = new Messreihe("Ort2");
    this.m43243.hinzufuegen(4);
    this.m43243.hinzufuegen(3);
    this.m43243.hinzufuegen(2);
    this.m43243.hinzufuegen(4);
    this.m43243.hinzufuegen(3);
    this.m2344 = new Messreihe("Ort3");
    this.m2344.hinzufuegen(2);
    this.m2344.hinzufuegen(3);
    this.m2344.hinzufuegen(4);
    this.m2344.hinzufuegen(4);
    this.m432432 = new Messreihe("Ort22");
    this.m432432.hinzufuegen(4);
    this.m432432.hinzufuegen(3);
    this.m432432.hinzufuegen(2);
    this.m432432.hinzufuegen(4);
    this.m432432.hinzufuegen(3);
    this.m432432.hinzufuegen(2);
    this.m332445 = new Messreihe("Ort11");
    this.m332445.hinzufuegen(3);
    this.m332445.hinzufuegen(3);
    this.m332445.hinzufuegen(2);
    this.m332445.hinzufuegen(4);
    this.m332445.hinzufuegen(4);
    this.m332445.hinzufuegen(5);
    this.leer = new Messreihe("Ort4");
    this.mitNullListe = new Messreihe("Ort5");
    this.mitNullListe.setMesswerte(null);
  }

  @Test
  public void test01() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertTrue(this.m33244.alleWerteGleichOft(this.m43243)
        , this.m33244 + " und " + this.m43243
            + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);        
  }
  
  @Test
  public void test01b() {
    this.merkeGenutzteWerte(this.m43243);
    Assertions.assertTrue(this.m33244.alleWerteGleichOft(this.m43243)
        , this.m33244 + " und " + this.m43243
            + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m43243)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m43243);        
  }

  @Test
  public void test02() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertTrue(!this.m33244.alleWerteGleichOft(this.m2344)
        , this.m33244 + " und " + this.m2344
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);
  }

  @Test
  public void test03() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertFalse(this.m33244.alleWerteGleichOft(this.leer)
        , this.m33244 + " und " + this.leer
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);  
  }

  @Test
  public void test04() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertTrue(this.m33244.alleWerteGleichOft(this.m33244)
        , this.m33244 + " und " + this.m33244
            + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);
  }

  @Test
  public void test05() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertTrue(!this.m33244.alleWerteGleichOft(this.m432432)
        , this.m33244 + " und " + this.m432432
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);
  }

  @Test
  public void test06() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertTrue(!this.m33244.alleWerteGleichOft(this.m332445)
        , this.m33244 + " und " + this.m332445
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);
  }

  @Test
  public void test07() {
    this.merkeGenutzteWerte(this.m43243);
    Assertions.assertTrue(this.m43243.alleWerteGleichOft(this.m33244)
        , this.m43243 + " und " + this.m33244
            + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m43243)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m43243);
  }

  @Test
  public void test08() {
    this.merkeGenutzteWerte(this.m2344);
    Assertions.assertTrue(!this.m2344.alleWerteGleichOft(this.m43243)
        , this.m2344 + " und " + this.m43243
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m2344)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m2344);
  }

  @Test
  public void test09() {
    this.merkeGenutzteWerte(this.m432432);
    Assertions.assertTrue(
        !this.m432432.alleWerteGleichOft(this.m33244)
        , this.m432432 + " und " + this.m33244
          + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m432432)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m432432);
  }

  @Test
  public void test10() {
    this.merkeGenutzteWerte(this.m332445);
    Assertions.assertTrue(
        !this.m332445.alleWerteGleichOft(this.m33244)
        , this.m332445 + " und " + this.m33244
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m332445)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m332445);
  }

  @Test
  public void test11() {
    this.merkeGenutzteWerte(this.leer);
    Assertions.assertTrue(
        this.leer.alleWerteGleichOft(this.leer)
        , this.leer + " und " + this.leer + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.leer)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.leer);    
  }

  @Test
  public void test12() {
    this.merkeGenutzteWerte(this.m33244);
    Assertions.assertTrue(
        !this.mitNullListe.alleWerteGleichOft(this.m33244)
        , this.mitNullListe + " und " + this.m33244
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m33244);
  }

  @Test
  public void test13() {
    this.merkeGenutzteWerte(this.leer);
    Assertions.assertTrue(
        this.mitNullListe.alleWerteGleichOft(this.leer)
        , this.mitNullListe + " und " + this.leer
            + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.leer)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.leer);
  }

  @Test
  public void test14() {
    this.merkeGenutzteWerte(this.mitNullListe);
    Assertions.assertTrue(
        this.mitNullListe.alleWerteGleichOft(this.mitNullListe)
        , this.mitNullListe + " und " + this.mitNullListe
            + " haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.mitNullListe);        
  }

  @Test
  public void test15() {
    this.merkeGenutzteWerte(this.mitNullListe);
    Assertions.assertTrue(
        !this.m33244.alleWerteGleichOft(this.mitNullListe)
        , this.m33244 + " und " + this.mitNullListe
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.mitNullListe);
  }
  
  @Test
  public void test16() {
    this.merkeGenutzteWerte(this.m332445);
    Assertions.assertFalse(this.m332445.alleWerteGleichOft(this.m432432)
        , this.m332445 + " und " + this.m432432
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m332445)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m332445);
  }
  
  @Test
  public void test17() {
    this.merkeGenutzteWerte(this.m432432);
    Assertions.assertFalse(this.m432432.alleWerteGleichOft(this.m332445)
        , this.m432432 + " und " + this.m332445
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m432432)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m432432);        
  }
  
  @Test
  public void test18() {
    this.merkeGenutzteWerte(this.m43243);
    this.m2344.hinzufuegen(2);
    Assertions.assertFalse(this.m43243.alleWerteGleichOft(this.m2344)
        , this.m43243 + " und " + this.m2344
            + " haben nicht die gleichen Werte");
            Assertions.assertTrue(this.messwerteUnveraendert(this.m43243)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m43243);
  }
  
  @Test
  public void test19() {
    this.m2344.hinzufuegen(2);
    this.merkeGenutzteWerte(this.m2344);
    Assertions.assertFalse(this.m2344.alleWerteGleichOft(this.m43243)
        , this.m2344 + " und " + this.m43243
            + " haben nicht die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.m2344)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.m2344);
  }
  
  @Test
  public void test20() {
    this.merkeGenutzteWerte(this.leer);
    Assertions.assertTrue(this.leer.alleWerteGleichOft(null)
        , "leere Liste und null haben die gleichen Werte");
    Assertions.assertTrue(this.messwerteUnveraendert(this.leer)
        , "urspruengliche Werte " + this.genutzt 
          + " sollten nicht geaendert werden:" + this.leer);    
  }  
}
