import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import java.util.ArrayList;

public class MessreiheVerschiedenTest{
    
    private Messreihe m33244;
    private Messreihe m1555;
    private Messreihe m41;
    private Messreihe leer;
    private Messreihe mitNullListe;
    private ArrayList<Integer> genutzt;

  private void merkeGenutzteWerte(Messreihe m){
    if (m.getMesswerte() == null){
      return;
    }
    for (int w: m.getMesswerte()) { // in Messreihe keine null-Werte
      this.genutzt.add(w);
    }
  }
  
  private boolean messwerteUnveraendert(Messreihe m){
    if (m.getMesswerte() == null){
      return this.genutzt.size() == 0;
    }
    for(int i = 0; i < this.genutzt.size(); i++) {
      if (this.genutzt.get(i) != m.getMesswerte().get(i)){
        return false;
      }
    }
    return m.getMesswerte().size() == this.genutzt.size();
  }
  
    @BeforeEach
    public void setUp() {
    this.genutzt = new ArrayList<Integer>();
        this.m33244 = new Messreihe("Ort1");
        this.m33244.hinzufuegen(3);
        this.m33244.hinzufuegen(3);
        this.m33244.hinzufuegen(2);
        this.m33244.hinzufuegen(4);
        this.m33244.hinzufuegen(4);
        this.m1555 = new Messreihe("Ort2");
        this.m1555.hinzufuegen(1);
        this.m1555.hinzufuegen(5);
        this.m1555.hinzufuegen(5);
        this.m1555.hinzufuegen(5);
        this.m41 = new Messreihe("Ort3");
        this.m41.hinzufuegen(4);
        this.m41.hinzufuegen(1);
        this.leer = new Messreihe("Ort4");
        this.mitNullListe = new Messreihe("Ort5");
        this.mitNullListe.setMesswerte(null);
    }

    @Test
    public void test01(){
        this.merkeGenutzteWerte(this.m33244);
        Assertions.assertTrue(this.m33244.verschieden(this.m1555)
            , this.m33244 + " und " + this.m1555 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m33244);    
    }
    
    @Test
    public void test01b(){
        this.merkeGenutzteWerte(this.m1555);
        Assertions.assertTrue(this.m33244.verschieden(this.m1555)
            , this.m33244 + " und " + this.m1555 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m1555)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m1555);    
    }

    @Test
    public void test02(){
        this.merkeGenutzteWerte(this.m33244);
        Assertions.assertTrue(!this.m33244.verschieden(this.m41)
            , this.m33244 + " und " + this.m41 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m33244);      
    }
    
    @Test
    public void test02b(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(!this.m33244.verschieden(this.m41)
            , this.m33244 + " und " + this.m41 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);      
    }    
    
    @Test
    public void test03(){
        this.merkeGenutzteWerte(this.m33244);
        Assertions.assertTrue(this.m33244.verschieden(this.leer)
            , this.m33244 + " und " + this.leer + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m33244);
    }
    
    @Test
    public void test04(){
        this.merkeGenutzteWerte(this.m33244);
        Assertions.assertTrue(!this.m33244.verschieden(this.m33244)
            , this.m33244 + " und " + this.m33244 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m33244)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m33244);
    }
 
    @Test
    public void test05(){
        this.merkeGenutzteWerte(this.m1555);
        Assertions.assertTrue(!this.m1555.verschieden(this.m1555)
            , this.m1555 + " und " + this.m1555 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m1555)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m1555);
    }

    @Test
    public void test06(){
        this.merkeGenutzteWerte(this.m1555);
        Assertions.assertTrue(!this.m1555.verschieden(this.m41)
            , this.m1555 + " und " + this.m41 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m1555)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m1555);
    }
    
    @Test
    public void test07(){
        this.merkeGenutzteWerte(this.m1555);
        Assertions.assertTrue(this.m1555.verschieden(this.leer)
            , this.m1555 + " und " + this.leer + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m1555)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m1555);
    }
    
    @Test
    public void test08(){
        this.merkeGenutzteWerte(this.m1555);
        Assertions.assertTrue(this.m1555.verschieden(this.m33244)
            , this.m1555 + " und " + this.m33244 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m1555)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m1555);    
    }    

    @Test
    public void test09(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(!this.m41.verschieden(this.m1555)
            , this.m41 + " und " + this.m1555 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);     
    }

    @Test
    public void test10(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(!this.m41.verschieden(this.m41)
            , this.m41 + " und " + this.m41 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);     
    }
    
    @Test
    public void test11(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(this.m41.verschieden(this.leer)
            , this.m41 + " und " + this.leer + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);     
    }
    
    @Test
    public void test12(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(!this.m41.verschieden(this.m33244)
            , this.m41 + " und " + this.m33244 + " sind nicht verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);     
    }     
    
     @Test
    public void test13(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(this.leer.verschieden(this.m1555)
            , this.leer + " und " + this.m1555 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);     
    }

    @Test
    public void test14(){
        this.merkeGenutzteWerte(this.m41);
        Assertions.assertTrue(this.leer.verschieden(this.m41)
            , this.leer + " und " + this.m41 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.m41)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.m41);     
    }
    
    @Test
    public void test15(){
        this.merkeGenutzteWerte(this.leer);
        Assertions.assertTrue(this.leer.verschieden(this.leer)
            , this.leer + " und " + this.leer + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.leer)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.leer);     
    }
    
    @Test
    public void test16(){
        this.merkeGenutzteWerte(this.leer);
        Assertions.assertTrue(this.leer.verschieden(this.m33244)
            , this.leer + " und " + this.m33244 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.leer)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.leer);    
    }    
 
    @Test
    public void test17(){
        this.merkeGenutzteWerte(this.mitNullListe);
        Assertions.assertTrue(this.mitNullListe.verschieden(this.m33244)
            , this.mitNullListe + " und " + this.m33244 + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.mitNullListe);    
    }
    
    @Test
    public void test18(){
        this.merkeGenutzteWerte(this.mitNullListe);
        Assertions.assertTrue(this.mitNullListe.verschieden(this.leer)
            , this.mitNullListe + " und " + this.leer + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.mitNullListe);    
    }   
    
    @Test
    public void test19(){
        this.merkeGenutzteWerte(this.mitNullListe);
        Assertions.assertTrue(this.mitNullListe.verschieden(this.mitNullListe)
            , this.mitNullListe + " und " + this.mitNullListe + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.mitNullListe);    
    }    
    
    @Test
    public void test20(){
        this.merkeGenutzteWerte(this.mitNullListe);
        Assertions.assertTrue(this.m33244.verschieden(this.mitNullListe)
            , this.m33244 + " und " + this.mitNullListe + " sind verschieden");
        Assertions.assertTrue(this.messwerteUnveraendert(this.mitNullListe)
            , "urspruengliche Werte " + this.genutzt 
                + " sollten nicht geaendert werden:" + this.mitNullListe);    
    }     
}
